.global GetR10, PutR10, GetR9, PutR9, memset, memcpy, memset16, memset8

GetR10:
    mov	r0, r10
    mov	pc, lr
    
PutR10:
    mov	r10, r0
    mov	pc, lr

GetR9:
    mov	r0, r9
    mov	pc, lr
    
PutR9:
    mov	r9, r0
    mov	pc, lr

memcpy:
    stmdb sp!, {r0, lr}
    cmp r0, #0
    beq memcpy_exit
    cmp r1, #0
    beq memcpy_exit
    cmp r2, #0
    beq memcpy_exit

    tst r0, #1
    bne memcpy_1
    tst r1, #1
    bne memcpy_1
    tst r2, #1
    bne memcpy_1

memcpy_2:
    ldrh r3, [r1], #2
    strh r3, [r0], #2
    subs r2, r2, #2
    bne memcpy_2
	  ldmia sp!, {r0, pc}

memcpy_1:
    ldrb r3, [r1], #1
    strb r3, [r0], #1
    subs r2, r2, #1
    bne memcpy_1
    
memcpy_exit:
	  ldmia sp!, {r0, pc}


memset:
    stmdb sp!, {r0, lr}
    cmp r2, #0
    beq memset_exit
    cmp r0, #0
    beq memset_exit
    orr r1, r1, r1, lsl #8
    orr r1, r1, r1, lsl #16

memset1_1:
    tst r0, #3
    beq memset_4
    strb r1, [r0], #1
    subs r2, r2, #1
    bne memset1_1
	  ldmia sp!, {r0, pc}

memset_4:
    cmp r2, #3
    ble memset1_2
    str r1, [r0], #4
    subs r2, r2, #4
    bne memset_4
	  ldmia sp!, {r0, pc}

memset1_2:
    strb r1, [r0], #1
    subs r2, r2, #1
    bne memset1_2

memset_exit:
	  ldmia sp!, {r0, pc}


memset16:
    stmdb sp!, {r0, r4, r5, r6, r7, lr}
    cmp r2, #0
    beq memset16_exit
    cmp r0, #0
    beq memset16_exit
    orr r1, r1, r1, lsl #8
    orr r4, r1, r1, lsl #16
		mov r5, r4
		mov r6, r4
		mov r7, r4
		
memset16_loop:
    stmia r0!, {r4, r5, r6, r7}
    subs r2, r2, #16
    bne memset16_loop

memset16_exit:
	  ldmia sp!, {r0, r4, r5, r6, r7, pc}


memset8:
    orr r1, r1, r1, lsl #8
    orr r1, r1, r1, lsl #16
    str r1, [r0]
    str r1, [r0, #4]
    mov	pc, lr
