#ifndef _PALMOSFILEIO_H
#define _PALMOSFILEIO_H

// Declaration
void InitDB(void) CODE2_SECTION;
void FreeDB(void) CODE2_SECTION;
void Load(DbFile* dbf, UInt16 idx, UInt16 card) CODE2_SECTION;
void Close(FILE *) CODE2_SECTION;
void SaveFile2SD(FILE *f) CODE2_SECTION;
void SaveSnapshot(char *name, Int32 idx) CODE2_SECTION;
void SaveSnapshot2SD(char *name, UInt16 card) CODE2_SECTION;
Err LoadSnapshotFromSD(UInt16 card, char *name) CODE2_SECTION;
UInt16 SavePrefsPalm(void) CODE2_SECTION;
UInt16 SavePrefs(void) CODE2_SECTION;

// Handle list of files
void FreeItems(void) CODE2_SECTION;
Err Scan(DbFile *, UInt16, char *) CODE2_SECTION;
Err AddFile(UInt16, char *) CODE2_SECTION;
Err AddItem(UInt16, char *) CODE2_SECTION;
Err Grow(MemHandle *, MemPtr *, UInt16, UInt16, UInt16 *) CODE2_SECTION;
Err ScanIndex(FileRef, UInt16, char *) CODE2_SECTION;
void ScanFiles(FormPtr) CODE2_SECTION;
Err LoadFile(UInt16 card, char *name) CODE2_SECTION;
void LoadSelectedFile(UInt16) CODE2_SECTION;
void LoadSpecifiedFile(UInt16 card, UInt16 index, char *name) CODE2_SECTION;
void Delete(DbFile *, UInt16) CODE2_SECTION;
void DeleteFile(UInt16) CODE2_SECTION;
Err VFSRead(FileRef f, UInt32 n, void *vP) CODE2_SECTION;
Boolean CheckFileExists(UInt16 card, UInt16 index, char *name) CODE2_SECTION;
UInt16 SearchValidCard(void) CODE2_SECTION;


#ifndef _PALMOSFILEIO_C
extern DmOpenRef mainDBRef;
extern FileRef mainFileRef;
extern Int32 lastIndex;
extern char lastName[32];
extern UInt16 lastCard;
#endif


#endif


