//
//  PRCItem.java
//  C64Palmer
//
//  Created by Johan Forsberg on Thu Aug 28 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

import java.io.*;

public class PDBItem {
    static int PARTSIZE=60<<10;
    static int HDRSIZE=52;
    public String name;
    public byte content[];
    boolean isSnap=false;
    byte snapPart[][]=new byte[2][];
    
    public PDBItem(String n, byte c[]) {
        content=c;
	name=n;
	checkName();
    }
    void checkName() {
        String n=name;
	char l;
	int i, j, len;
	for (i=j=0; i<n.length(); i++) {
		l=n.charAt(i);
		if ((l>='a' && l<='z') || (l>='A' && l<='Z') ||
		    (l>='0' && l<='9') || "-_. ".indexOf(l)>=0)
			j++;
	}
	len=j;
	boolean abr=false;
	if (len>31) {
		abr=true;
		len=31;
	}
	char cs[]=new char[len];
	for (i=j=0; i<n.length(); i++) {
		if (abr && j>=len-6) break;
		
		l=n.charAt(i);
		if ((l>='a' && l<='z') || (l>='A' && l<='Z') ||
		    (l>='0' && l<='9') || "-_. ".indexOf(l)>=0)
			cs[j++]=l;
	}
	if (abr) {
		cs[len-6]='.';
		cs[len-5]='.';
		cs[len-4]='.';
		cs[len-3]=n.charAt(n.length()-3);
		cs[len-2]=n.charAt(n.length()-2);
		cs[len-1]=n.charAt(n.length()-1);
	}
	if (cs[j-3]=='D') cs[j-3]='d';
	if (cs[j-3]=='T') cs[j-3]='t';
	name=new String(cs);	
    }
    public PDBItem(String name, byte[] p1, byte p2[]) {
	// A snapshot, in two parts
	isSnap=true;
	this.name=name;
	snapPart[0]=p1;
	snapPart[1]=p2;
	checkName();
    }
    public int elements() {
        if (isSnap) return 2;
	if (content.length%PARTSIZE==0)
		return content.length/PARTSIZE;
	return content.length/PARTSIZE + 1;
    }
    public int size() {
        if (isSnap) return snapPart[0].length+snapPart[1].length;
	return content.length+elements()*HDRSIZE;
    }
    public int elementSize(int i) {
	int e=elements();
	
	if (isSnap) return snapPart[i].length;
	if (i>=e || i<0) return 0;
	if (i<e-1) return PARTSIZE+HDRSIZE;
	return content.length%PARTSIZE+HDRSIZE;
    }
    // Write SplitFile.
    /* Current layout:
        'SPLT'
	byte name[32]
	int totalParts
	int part
	int size
	int partSize
	data
    */
    public void write(OutputStream os) throws IOException {
	int i, e=elements(), offs=0, siz;
	String n=name;
	
	if (isSnap) {
		os.write(snapPart[0]);
		os.write(snapPart[1]);
		return;
	}
	
	for (i=0; i<e; i++) {
		if (i==0) {
			os.write('S'); os.write('P'); os.write('L'); os.write('T');
		} else {
			os.write('P'); os.write('A'); os.write('R'); os.write('T');
		}
		for (int j=0; j<32; j++)
			if (j<n.length())
				os.write(n.charAt(j));
			else
				os.write(0);
		os.write((e>>24)&0xff); os.write((e>>16)&0xff);
		os.write((e>>8)&0xff);  os.write(e&0xff);
		os.write((i>>24)&0xff); os.write((i>>16)&0xff);
		os.write((i>>8)&0xff);  os.write(i&0xff);
		siz=content.length;
		os.write((siz>>24)&0xff); os.write((siz>>16)&0xff);
		os.write((siz>>8)&0xff); os.write(siz&0xff);
		siz=elementSize(i)-HDRSIZE;
		os.write((siz>>24)&0xff); os.write((siz>>16)&0xff);
		os.write((siz>>8)&0xff); os.write(siz&0xff);
		os.write(content, offs, siz);
		offs+=siz;
	}
    }
}
